zsh-users
 help / color / mirror / code / Atom feed
From: Joke de Buhr <joke@seiken.de>
To: zsh-users@zsh.org
Subject: Re: Exit value of command glob qualifier within for loop
Date: Tue, 29 Jun 2010 09:56:29 +0200	[thread overview]
Message-ID: <201006290956.31636.joke@seiken.de> (raw)

[-- Attachment #1: Type: text/plain, Size: 2343 bytes --]

On Tuesday 29 June 2010 05:05:56 Benjamin R. Haskell wrote:
> On Sun, 27 Jun 2010, Joke de Buhr wrote:
> > Hi,
> > 
> > I'm using a for loop with glob qualifiers to process a list of altered
> > 
> > files. It looks like this:
> >     for a in *(e:age today:); do some_command $a ; done
> > 
> > The problem, I've enabled the option PRINT_EXIT_VALUE. Now zsh echoes
> > the line "zsh: exit 1"  for every file which doesn't match the
> > qualifier.
> > 
> > If I use this (builtin) command zsh reports the exit status as well:
> >     print *(e:age today:)
> > 
> > But if I use this (external) command zsh doesn't:
> >     ls *(e:age today:)
> > 
> > I'm not sure if this behavior is intentional but it sure is annoying.
> > Disabling PRINT_EXIT_VALUE before running these commands doesn't make
> > that much fun. I think zsh shouldn't print the exit value at all.
> 
> Maybe not the answer you're hoping for, but with very recent zsh[1], the
> following pair of commands can provide an effect similar to
> PRINT_EXIT_VALUE while specifically excluding a non-zero return status
> when inside a glob qualifier:
> 
> # $1 $2 and $3 are possibly-different versions of the command
> # $1 seemed fine to me
> preexec () { _debug_lastcmd=$1 }
> 
> # Print "(command): exit (status)" to stderr,
> # unless context contains globqual
> TRAPZERR () {
> 	local ret=$?
> 	if (( ! $zsh_eval_context[(Ie)globqual] )) ; then
> 		printf "%s: exit %d\n" $_debug_lastcmd $? >&2
> 	fi
> }
> 
> NB. I never use PRINT_EXIT_VALUE, nor do I plan to, so I'm not sure what
> behaviors might be different, behavior-wise.  I suspect that
> PRINT_EXIT_VALUE is finer-grained in its output, for starters.

You're right it isn't (shouldn't) be quite that powerful as PRINT_EXIT_VALUE.
PRINT_EXIT_VALUE has the benefit of printing the exit values of commands within 
piped expressions in case something went wrong.

    $ print "asdf" | cat | false | cat   
    zsh: done       print "asdf" | cat | 
    zsh: exit 1     false | 
    zsh: done       cat

The suggested code seems to be more like a "only the last" exit value just 
like the last exit value echoed within prompts. It's a good think I'm not 
using glob qualifiers with commands that often so it's not too complicated to 
ignore the "zsh: exit 1" lines.

[-- Attachment #2: This is a digitally signed message part. --]
[-- Type: application/pgp-signature, Size: 706 bytes --]

             reply	other threads:[~2010-06-29  7:56 UTC|newest]

Thread overview: 3+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2010-06-29  7:56 Joke de Buhr [this message]
  -- strict thread matches above, loose matches on Subject: below --
2010-06-27 21:48 Joke de Buhr
2010-06-29  3:05 ` Benjamin R. Haskell

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=201006290956.31636.joke@seiken.de \
    --to=joke@seiken.de \
    --cc=zsh-users@zsh.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.vuxu.org/mirror/zsh/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).